=== debian/changelog ===
cmark-gfm (0.29.0.gfm.13-7) unstable; urgency=medium

  * Request cmake version 3.0 compatibility. (Closes: #1112797)

 -- Keith Packard <keithp@keithp.com>  Sun, 31 Aug 2025 21:14:43 -0500

cmark-gfm (0.29.0.gfm.13-6) unstable; urgency=medium

  * Adjust python3 build dependency, adding :native, to allow cross builds

 -- Keith Packard <keithp@keithp.com>  Fri, 18 Jul 2025 16:19:42 +0200

cmark-gfm (0.29.0.gfm.13-5) unstable; urgency=medium

  * Apply patches as forwarded upstream.

 -- Keith Packard <keithp@keithp.com>  Mon, 06 Jan 2025 08:51:45 -0800

cmark-gfm (0.29.0.gfm.13-4) unstable; urgency=medium

  * Fix lintian complaints

 -- Keith Packard <keithp@keithp.com>  Sun, 05 Jan 2025 17:22:56 -0800

cmark-gfm (0.29.0.gfm.13-3) unstable; urgency=medium

  * Increase pathological_tests.py timeout to 50 seconds to help hppa
    succeed in building.

 -- Keith Packard <keithp@keithp.com>  Sun, 05 Jan 2025 16:55:13 -0800

cmark-gfm (0.29.0.gfm.13-2) unstable; urgency=medium

  * Clean up test/__pycache__. (Closes: #1043789)
  * Add missing command line options to man page. (Closes: #1027969)
  * Extend test timeouts to allow hppa more time.

 -- Keith Packard <keithp@keithp.com>  Sun, 05 Jan 2025 09:23:04 -0800

cmark-gfm (0.29.0.gfm.13-1) unstable; urgency=medium

  * New upstream version.

  * Resolves: CVE-2023-37463. (Closes: #1041097)

  * Resolves: CVE-2023-26485 CVE-2023-24824. (Closes: #1034171)

  * Resolves: CVE-2023-22483 CVE-2023-22484 CVE-2023-22485
    CVE-2023-22486. (Closes: #1033110)

 -- Keith Packard <keithp@keithp.com>  Sat, 04 Jan 2025 12:21:02 -0800
