=== debian/control ===
Source: cmark-gfm
Section: text
Priority: optional
Homepage: https://github.com/github/cmark
Maintainer: Keith Packard <keithp@keithp.com>
Build-Depends: debhelper-compat (= 13), cmake, python3:native
Rules-Requires-Root: no
Standards-Version: 4.7.0

Package: cmark-gfm
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: CommonMark parsing and rendering program, GitHub flavor
 cmark-gfm is the GitHub flavor of the cmark C reference
 implementation of CommonMark, a rationalized version of Markdown
 syntax with a spec.  This package provides a command-line program
 (cmark-gfm) for parsing and rendering CommonMark documents.
 .
 This GitHub flavored version has extensions for org-mode style
 tables, auto-linking, and more.

Package: libcmark-gfm0.29.0.gfm.13
Architecture: any
Section: libs
Multi-Arch: same
Replaces: libcmark-gfm0 (>= ${source:Upstream-Version})
Breaks: libcmark-gfm0 (>= ${source:Upstream-Version})
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: CommonMark GitHub flavor gfm library
 cmark-gfm is the GitHub flavor of the cmark C reference
 implementation of CommonMark, a rationalized version of Markdown
 syntax with a spec. This package provides the required gfm
 library

Package: libcmark-gfm-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends: ${misc:Depends}, libcmark-gfm0.29.0.gfm.13 (= ${binary:Version})
Description: CommonMark GitHub flavor gfm library dev files
 cmark-gfm is the GitHub flavor of the cmark C reference
 implementation of CommonMark, a rationalized version of Markdown
 syntax with a spec. This package provides the development files for
 the gfm library

Package: libcmark-gfm-extensions0.29.0.gfm.13
Architecture: any
Section: libs
Multi-Arch: same
Replaces: libcmark-gfm-extensions0 (>= ${source:Upstream-Version})
Breaks: libcmark-gfm-extensions0 (>= ${source:Upstream-Version})
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: CommonMark GitHub flavor gfm extension library
 cmark-gfm is the GitHub flavor of the cmark C reference
 implementation of CommonMark, a rationalized version of Markdown
 syntax with a spec. This package provides the required gfm extension
 library

Package: libcmark-gfm-extensions-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends: ${misc:Depends}, libcmark-gfm-extensions0.29.0.gfm.13 (= ${binary:Version})
Description: CommonMark GitHub flavor gfm extensions library dev files
 cmark-gfm is the GitHub flavor of the cmark C reference
 implementation of CommonMark, a rationalized version of Markdown
 syntax with a spec. This package provides the development files for
 the gfm extensions library
