=== debian/tests/control ===
Tests: upstream
Restrictions: build-needed
Depends: @builddeps@
