=== debian/watch ===
version=4
opts="mode=git, gitmode=full, pgpmode=none" \
https://github.com/github/cmark-gfm \
refs/tags/([\d\.]+gfm[\d\.]+) debian uupdate
